#ifndef WX_PRECOMP
    #include "wx/wx.h"
#else
#include <wx/wxprec.h>
#endif
#include <wx/textdlg.h>
#include <wx/textfile.h>
#include <wx/datetime.h>
#include "ScilabThread.h"
//#include "stack-c.h" /* Provide functions to access to the memory of Scilab */
#include "call_scilab.h" /* Provide functions to call Scilab engine */
#include <fstream>
#include <stdio.h> /* stderr */
using namespace std;
#include "SciWebLabConfig.h"

#define SHELLSCILAB

wxCriticalSection ScilabThread::scilabLibre;
string dossierLog;

void Pistage(int numEtape)
{
string s(dossierLog+"/erreurScilabServeur.txt");
ofstream gg(s.c_str(),ios::out);
gg<<numEtape<<endl;;
gg.close();
}
void Pistage(wxString s,int numEtape)
{
string ss(dossierLog+"/erreurScilabServeur.txt");
ofstream gg(ss.c_str(),ios::out);
gg<<s<<"\t"<<numEtape<<endl;;
gg.close();
}


void Pistage(wxString s)
{
string ss(dossierLog+"/erreurScilabServeur.txt");
ofstream gg(ss.c_str(),ios::out);
gg<<"wxChaine "<<s<<endl;;
gg.close();
}

void Pistage(char *s)
{
string ss(dossierLog+"/erreurScilabServeur.txt");
ofstream gg(ss.c_str(),ios::out);
gg<<"CChaine "<<s<<endl;;
gg.close();
}

ScilabThread::ScilabThread(wxString s,char scilabInactif): wxThread(wxTHREAD_JOINABLE )
{
wxTextFile	fConfig("config.txt");
int			indPort;
string		chaine1,chaine2;

fConfig.Open();
if (!fConfig.IsOpened())
	{
	wxMessageBox("Fichier de configuration absent");
	wxExit();
	}
fConfig.GetFirstLine();
chaine1=fConfig.GetNextLine();
// Dossier o sont rangs les scripts scilab
nomDossierScilab=chaine1;
int pos=nomDossierScilab.Find("SCILAB_SCRIPT=");
nomDossierScilab= nomDossierScilab.SubString(pos+14,nomDossierScilab.Length());
cout<<chaine1<<" "<<nomDossierScilab<<endl;
// Dossier o seront rangs les rsultats 
chaine1=fConfig.GetNextLine();
nomDossierResultat=chaine1;
pos=nomDossierResultat.Find("SCILAB_RES=");
nomDossierResultat= nomDossierResultat.SubString(pos+11,nomDossierResultat.Length());
// Dossier o seront rangs les logs
chaine1=fConfig.GetNextLine();
nomDossierLog=chaine1;
pos=nomDossierLog.Find("LOG=");
nomDossierLog= nomDossierLog.SubString(pos+4,nomDossierLog.Length());
nomDossierResultat.Replace("\\","/");
nomDossierScilab.Replace("\\","/");
nomDossierLog.Replace("\\","/");
dossierLog=nomDossierLog;
fConfig.Close();

scilabActif = !scilabInactif;
item = s;
}


ScilabThread::~ScilabThread()
{
}

int ScilabThread::ScilabJob(wxString &s)
{
int status=0;
#ifdef SHELLSCILAB
gg2<<s<<endl;
#else
static char *tmp_str = new char[4096];
const wxWX2MBbuf tmp_buf = wxConvCurrent->cWX2MB(s);
const char *tmp_str1 = (const char*) tmp_buf;
strcpy(tmp_str,tmp_str1);
//status = SendScilabJob(tmp_str);
#endif
return status;
}

int ScilabThread::ScilabJob(char *s)
{
int status=0;
#ifdef SHELLSCILAB
gg2<<s<<endl;

#else
if (scilabActif)
	status = SendScilabJob(s);
#endif
return status;
}


wxString ScilabThread::ExtraireNomParamValParam(int indParam,wxString param,wxString &nomParam,wxString &valParam)
{

for (int i=0;i<=indParam;i++)
	{
	int pos1=param.find("=");
	int pos2=param.find("&");;
	if (pos2==wxNOT_FOUND)
		pos2=param.length();
	if(i==indParam)
		{
		nomParam =param.substr(0,pos1);
		valParam= param.substr(pos1+1,pos2-pos1-1);
		}
	else if (pos1!=wxNOT_FOUND && pos2 !=wxNOT_FOUND)
		param=param.substr(pos2+1,param.length()-pos2);
	}
return param;
}
wxThread::ExitCode ScilabThread::Entry()
{
	return Entree();
}

wxThread::ExitCode ScilabThread::Entree()
{
char *tmp_str = new char[4096];
if (!tmp_str)
	{
	Pistage("PB ALLOC NEW tmp_str");
	return NULL;
	}
#ifdef _MSC_VER
wxString shellScilab=" -noatomsautoload -nb -nouserstartup -f ";
#else
wxString shellScilab=" -noatomsautoload -nw -nb -nouserstartup -f ";
#endif
shellScilab = CHEMIN_SCILAB+shellScilab;
//s=_T("\"C:\\Program Files\\scilab-5.3.3\\bin\\Scilex.exe\" -nb -nouserstartup -f ");
Pistage(item,1);
int pos_=item.find("_");
int pos=item.find(" ");
if (pos_==wxNOT_FOUND || pos==wxNOT_FOUND)
	return NULL;
wxString ipAdresse=item.substr(0,pos_);
wxString indRequete=item.substr(pos_+1,pos-pos_-1);
wxString param=item.substr(pos+1,item.Len()-pos-1);
wxString paramOrig=item.substr(pos+1,item.Len()-pos-1);
wxString scriptScilab;
int	status=0;
scilabLibre.Enter();
wxString nomFichierConfig("test");
nomFichierConfig=nomDossierLog+"/"+nomFichierConfig+ipAdresse+".sci";
gg2.open((const char*)(nomFichierConfig.c_str()));
status = ScilabJob("clear");
Pistage(param,2);

wxString cmdScilab;
//gg2<<"ipAddr=\""<<ipAdresse<<"_"<<indRequete<<"\""<<endl;
cmdScilab.Printf("try;cd '%s';ipAddr=\"%s\";indReq=\"%s\";serrZeRt=0;",nomDossierResultat,ipAdresse,indRequete);
int nbParam=0;
int nbVariable=param.Freq('=');
Pistage("Nombre de variables",nbVariable);
{
status = ScilabJob(cmdScilab);
if (status)
	{
	Pistage("Erreur",1);
	Pistage(tmp_str,status);
	}
}
wxString nomParam,valParam;
wxString cmdSauvegarde("");
for (int i=0;i<nbVariable  ;i++)
	{
	ExtraireNomParamValParam(i,param,nomParam,valParam);
	if (valParam.length()==0)
		valParam = "0";
	variableCGI[nomParam]=valParam;
	if (nomParam=="script" ||nomParam=="username" || nomParam=="urlAbsolu" || nomParam=="horoReq" || nomParam=="page")
		{
		if (nomParam=="script")
			{
			scriptScilab=nomDossierScilab+"/"+valParam;
			}
		}
	else
		{
		if (nomParam.Contains("nomFic"))
			{
			if (valParam.Contains(".jpg"))
				{
				wxString tmp;
				tmp.Printf("%s=%s;xs2jpg(0,%s);",nomParam,valParam,nomParam);
				cmdSauvegarde += tmp;
				}
			else if (valParam.Contains(".wav"))
				{
				wxString tmp;
				tmp.Printf("%s=%s;wavwrite([0 1],44100,%s);",nomParam,valParam,nomParam);
				cmdSauvegarde += tmp;
				
				}
			cmdScilab.Printf("%s=%s;",nomParam,valParam);
			}
		else
			{
				valParam.Replace("\"","\"\"");
				cmdScilab.Printf("execstr(\"%s=%s;\");",nomParam,valParam);
			}

		status += ScilabJob(cmdScilab); // Will display   - 42.    42.
		if (status)
			{
			Pistage("Erreur",2);
#ifdef __MESSAGETHREAD__
			wxLogMessage("Scilab Error %s", tmp_str);
#endif
			}
		else
			{
#ifdef __MESSAGETHREAD__
			wxLogMessage("Scilab cmd %s", tmp_str);
#endif
			}
		}

	nbParam++;
	}

if (!status)
	{

//	cmdScilab="if exists(\"serrZeRt\")==1 if serrZeRt==0 exec(\""+scriptScilab+"\",-1);end;else exec(\""+scriptScilab+"\",-1);end";
	cmdScilab="exec(\""+scriptScilab+"\",-1);";
	status = ScilabJob(cmdScilab);
	if (status)
		{
			Pistage("Erreur",3);
			Pistage(tmp_str,status);
#ifdef __MESSAGETHREAD__
		wxLogMessage("Scilab Error %d : %s", status, tmp_str);
#endif
		}
	else
		{
#ifdef __MESSAGETHREAD__
		wxLogMessage("Scilab cmd %s", tmp_str);
#endif
		string ss(dossierLog+"/script.log");		
		ofstream serverLog(ss.c_str(),ios::app);
		wxDateTime now = wxDateTime::Now();

		serverLog<<now.Format("%c", wxDateTime::CET)<<"\t"<<ipAdresse<<"\t"<<indRequete<<"\t"<<scriptScilab<<"\t"<<paramOrig<<endl;
		}
	cmdScilab="x=0;save("+nomParam+",x)";
	{
		const wxWX2MBbuf tmp_buf1  = wxConvCurrent->cWX2MB(cmdScilab);
		const char *tmp_str1 = (const char*) tmp_buf1;
		strcpy(tmp_str,tmp_str1);
	}
	//status = ScilabJob((char*)tmp_str);
//	status = ScilabJob("if exists(\"serrZeRt\")==1 exit(serrZeRt);else clear;exit(0);end;");
	status = ScilabJob("exit(0);catch;[str,n,line,func]=lasterror();figure(0);clf();xrect(0,1,1,1);");
	status = ScilabJob("xstring(0,0.5,[str+ ' '+ string(n)+ ' '+ string(line)+ ' '+ func]);");
	status = ScilabJob(cmdSauvegarde);
	status = ScilabJob(";exit(0);end");
	
	
//	gg2<<"exec(\""<<scriptScilab<<"\",-1)"<<endl;
//	gg2<<"exit"<<endl;
	/* pour lancement par batch
	wxString nomFichierBat("test");
	nomFichierBat=nomFichierBat+ipAdresse+".bat";
	ofstream gg((const char*)(nomFichierBat.c_str()));
	gg<<s<<nomFichierConfig.c_str();
	gg.close();
	*/
#ifdef __MESSAGETHREAD__
	wxLogMessage("<Request for \"%s\"", s);
#endif
#ifdef SHELLSCILAB
wxString ligneCmd(shellScilab+"\""+nomFichierConfig+"\"");
if (scilabActif)
	wxExecute(ligneCmd,wxEXEC_SYNC);
#endif // SHELLSCILAB
	}
else
	{
	ScilabJob("exec(\"invalidParam.sce\",-1)");
	cmdScilab="x=0;save("+nomParam+",x)";
	ScilabJob(cmdScilab);
	}
gg2.close();
delete tmp_str;
scilabLibre.Leave();
}

