if exists('indReq')
    driver('JPG');
else
    driver('X11');
end
funcprot(0)
function r=ExporteGraphique(nomFic,num)
if exists('indReq')
    xinit(nomFic);
    xend();
    r=1;
else
    xs2jpg(num,nomFic);
    r=0;
end
return r;
endfunction
function texte=TableauHtml(titreTab,titreLig,titreCol,x)
// TitreTab titre du tableau HTML
// TitreLig titre de chacune des lignes du tableau
// TitreCol titre de chacune des colonnes du tableau
    [nbl nbc]=size(x);
    texte='<table align=center border=1><caption>'+titreTab+'<caption><tr>';
    if length(titreCol)>0
        ligne='<tr><td>'+titreCol(1)+'</td>'
        for j=1:nbc
            ligne=ligne+'<td>'+titreCol(j+1)+'</td>';
        end
    else  
       ligne='<tr><td> </td>'
    end
   
    texte=texte+ligne; 
    for i=1:nbl
        ligne='<tr>';
        if length(titreLig)>0
            ligne=ligne+'<td>'+titreLig(i)+'</td>';
        end
        
        for j=1:nbc
            ligne=ligne+'<td>'+string(x(i,j))+'</td>';
        end
        texte=texte+ligne+'</tr>';
    end
texte=texte+'</table>';
return texte;
endfunction

Fe=22050;
N=2^15;
t=(0:N-1)/Fe;
y=sin(2*%pi*FWeb*t);
wavwrite(y,Fe,nomFic0);  
figure(0)
mapsound(y,0.1,FWeb/4,min(FWeb*4,Fe/2),1,Fe)
ff=gcf(); ff.color_map=jetcolormap(64);

title('Spectrogramme du signal');
ExporteGraphique(nomFic1,0);
figure(1)
clf()
t=TableauHtml(' ',['i';'t';'y'],[],[(1:10); t(1:10);y(1:10)]);
fd = mopen(nomFic2,'wt');
mputl(t,fd);
mclose(fd);

